Educational Codeforces Round 33 (Rated for Div. 2) D题 【贪心:前缀和+后缀最值好题】

D. Credit Card

Recenlty Luba got a credit card and started to use it. Let's consider n consecutive days Luba uses the card.

She starts with 0 money on her account.

In the evening of i-th day a transaction ai occurs. If ai > 0, then ai bourles are deposited to Luba's account. If ai < 0, then ai bourles are withdrawn. And if ai = 0, then the amount of money on Luba's account is checked.

In the morning of any of n days Luba can go to the bank and deposit any positive integer amount of burles to her account. But there is a limitation: the amount of money on the account can never exceed d.

It can happen that the amount of money goes greater than d by some transaction in the evening. In this case answer will be «-1».

Luba must not exceed this limit, and also she wants that every day her account is checked (the days when ai = 0) the amount of money on her account is non-negative. It takes a lot of time to go to the bank, so Luba wants to know the minimum number of days she needs to deposit some money to her account (if it is possible to meet all the requirements). Help her!

Input
The first line contains two integers n, d (1 ≤ n ≤ 105, 1 ≤ d ≤ 109) —the number of days and the money limitation.

The second line contains n integer numbers a1, a2, ... an ( - 104 ≤ ai ≤ 104), where ai represents the transaction in i-th day.

Output
Print -1 if Luba cannot deposit the money to her account in such a way that the requirements are met. Otherwise print the minimum number of days Luba has to deposit money.

Input

5 10
-1 5 0 -5 3

Output

0

Input

3 4
-10 0 20

Output

-1

思路:首先由于每次充钱我们只需要保证账户金额不超过d就可以无限充钱,那么我们不会因为检查时金额为负数而输出-1,因为我们一定有能力在检查的那天白天把金额充值到正数。现在的问题是,任何一天的白天金额不能超过d,且希望充值次数最少。所以在每次必须充值的时候,我们尽量多充一些,充多少由后面的前缀最大值定。假设未来的最大前缀是f[j],那么此时最多只能充d - f[j]。(参考博客)

AC代码:

#include<bits/stdc++.h>

using namespace std;
#define N 1250000
int arr[N];
int sum[N];// 前缀和
int f[N];//从后面跑出的最大值 
int main(){
    int n,d;
    scanf("%d%d",&n,&d);
    for(int i=1;i<=n;i++)
        scanf("%d",&arr[i]);
    sum[0]=0;
    for(int i=1;i<=n;i++)
        sum[i]=sum[i-1]+arr[i];// 前缀和 
    f[n]=sum[n];
    for(int i=n-1;i>=1;i--)
        f[i]=max(f[i+1],sum[i]);// 最大值
    int ans=0;// 需要增加的钱  的数目 
    int res=0;// 需要增加的钱  的金额 
    for(int i=1;i<=n;i++){
        if(!arr[i]){
            if(sum[i]+res<0){ // 给钱的范围 --(不能超过接下来的最大值) 
                res+=d-(f[i]+res);
                ans++;
            }
            if(res+sum[i]<0){  // 如果钱还是为负数。则不符合 
                puts("-1");
                return 0;
            }
        }else{
            if(res+sum[i]>d){// 
                puts("-1");
                return 0;
            }
        }
    }
    printf("%d\n",ans);
    return 0;
} 

 

猜你喜欢

转载自www.cnblogs.com/pengge666/p/11512315.html